<?php
    /*
    * Module GalleryFP pour Joomla! 3.x
    * Version J4.0P
    * Creation date: Mai 2022
    * Author: Fabrice4821 - www.gmapfp.org
    * Author email: webmaster@gmapfp.org
	* License GNU/GPL
    */

// no direct access
defined('_JEXEC') or die;

use Joomla\CMS\Factory;

class pkg_galleryfpInstallerScript{

	function preflight($type, $parent) 
	{
        // $this->release = $parent->get( "manifest" )->version; //Version en installation

		if($type=='update'){
			//version avant installation.
			$db = Factory::getDBO();
			$query = $db->getQuery(true);
			$query = "SELECT manifest_cache FROM `#__extensions` WHERE element = 'mod_galleryfp'";
			$db->setQuery( $query );
			$manifest_cache = $db->loadResult();
			
/*			if ($manifest_cache != '')
			{
				$manifest_cache = json_decode($manifest_cache);
				$version = $manifest_cache->version;
				
				$pro_free = substr($version, -1);
				$indice = substr(strstr($version, '.'), 1, -1);
				if ($indice == '') $indice = substr(strstr($version, '_'), 1, -1);
				if (($pro_free == 'F' and $indice <= 7) or ($pro_free == 'P' and $indice <= 26)) {
				//déplace les répertoires des photos.
					if (JFolder::exists(JPATH_SITE."/modules/mod_galleryfp/galleries/"))
						JFolder::copy(JPATH_SITE."/modules/mod_galleryfp/galleries/", JPATH_SITE."/media/mod_galleryfp/galleries/", '', true);
				}
			}
*/		}
	}
 	
	function postflight($type, $parent) 
	{
		if($type=='install' || $type=='update'){
			// $parent is the class calling this method
			// $type is the type of change (install, update or discover_install)
			// $manifest = $parent->get('manifest');

			// Load language file for module
			$lang		= Factory::getLanguage();
			$langue		= substr((@$lang->getTag()),0,2);
			if ($langue!='fr') $langue = 'en';

			if ($langue=='fr') {
				echo '<h2>Installation de GalleryFP : la galerie d\'image simple d\'utilisation.</h2>';
				echo "<a href='http://gmapfp.org'><img src='../modules/mod_galleryfp/logo/logo_GMapFP_dev.png'/></a>
				<a href='http://joomla-slideshow.com/fr/'>GalleryFP</a> est un module Joomla de Galerie d'image développé par GMapFP.<br/>
				Ajouter facilement vos images grace à sa fonction glisser/déposer.";
			} else {
				echo '<h2>GalleryFP installation : the simple image gallery to use.</h2>';
				echo "<a href='http://gmapfp.org'><img src='../modules/mod_galleryfp/logo/logo_GMapFP_dev.png'/></a>
				<a href='http://joomla-slideshow.com/en/'>GalleryFP</a> is a Joomla Module image gallery developed by GMapFP.<br/>
				Easily add your pictures thanks to its drag/drop.";
			}
		}
		return true;
	}
}