/**
	* LivresFP : Component flipping book for Joomla! 4.x
	* Version J4.0F
	* Creation date: Mai 2022
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: support@gmapfp.org
	*
	* @copyright   Copyright (C) 2011 - 2021 GMapFP, Inc. All rights reserved.
	* @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

var token = Joomla.getOptions('csrf.token');
var module_id = Joomla.getOptions('module-edit').itemId
var drag_obj_fp = null;
var Base64={_keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",encode:function(e){var t="";var n,r,i,s,o,u,a;var f=0;e=Base64._utf8_encode(e);while(f<e.length){n=e.charCodeAt(f++);r=e.charCodeAt(f++);i=e.charCodeAt(f++);s=n>>2;o=(n&3)<<4|r>>4;u=(r&15)<<2|i>>6;a=i&63;if(isNaN(r)){u=a=64}else if(isNaN(i)){a=64}t=t+this._keyStr.charAt(s)+this._keyStr.charAt(o)+this._keyStr.charAt(u)+this._keyStr.charAt(a)}return t},decode:function(e){var t="";var n,r,i;var s,o,u,a;var f=0;e=e.replace(/[^A-Za-z0-9+/=]/g,"");while(f<e.length){s=this._keyStr.indexOf(e.charAt(f++));o=this._keyStr.indexOf(e.charAt(f++));u=this._keyStr.indexOf(e.charAt(f++));a=this._keyStr.indexOf(e.charAt(f++));n=s<<2|o>>4;r=(o&15)<<4|u>>2;i=(u&3)<<6|a;t=t+String.fromCharCode(n);if(u!=64){t=t+String.fromCharCode(r)}if(a!=64){t=t+String.fromCharCode(i)}}t=Base64._utf8_decode(t);return t},_utf8_encode:function(e){e=e.replace(/rn/g,"n");var t="";for(var n=0;n<e.length;n++){var r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r)}else if(r>127&&r<2048){t+=String.fromCharCode(r>>6|192);t+=String.fromCharCode(r&63|128)}else{t+=String.fromCharCode(r>>12|224);t+=String.fromCharCode(r>>6&63|128);t+=String.fromCharCode(r&63|128)}}return t},_utf8_decode:function(e){var t="";var n=0;var r=c1=c2=0;while(n<e.length){r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r);n++}else if(r>191&&r<224){c2=e.charCodeAt(n+1);t+=String.fromCharCode((r&31)<<6|c2&63);n+=2}else{c2=e.charCodeAt(n+1);c3=e.charCodeAt(n+2);t+=String.fromCharCode((r&15)<<12|(c2&63)<<6|c3&63);n+=3}}return t}}

function init_photos()
{		
	drag_obj_fp = jQuery("#drag_photos_fp");
	
	// init_drop_down photos;
	jQuery('#upload_photofp_button').on('click',function(){
		jQuery('#upload_photofp_input').trigger('click');
		return false;
	});
	
	jQuery('#upload_photofp_input').on('change',function(ev){
		var files = ev.target.files;
		handleFileUpload(files,drag_obj_fp);
		return false;
	});

	// init_drop_down videos;
	jQuery('#add_video_button').on('click',function(){
		$('#mes_photos_fp .liste_pitures').append(make_video_tram());
		return false;
	});
	/*Gestion du drag drop*/

	drag_obj_fp.on('dragenter', function (e) 
	{
		e.stopPropagation();
		e.preventDefault();
		jQuery(this).css('border', '2px solid #0B85A1');
	});
	drag_obj_fp.on('dragover', function (e) 
	{
		 e.stopPropagation();
		 e.preventDefault();
	});
	drag_obj_fp.on('drop', function (e) 
	{
		 jQuery(this).css('border', '2px dotted #0B85A1');
		 e.preventDefault();
		 var files = e.originalEvent.dataTransfer.files;
	 
		 //We need to send dropped files to Server
		 handleFileUpload(files,drag_obj_fp);
	});
	
}

function make_video_tram() {
	video_index++;
    jQuery.ajax({
        url: 'index.php?option=com_ajaxgallerydropfilesfp&task=add_video&'+token+'=1&module_id='+module_id+'&video_index='+video_index,
        method: "POST",
        contentType:false,
        processData: false,
		enctype: 'multipart/form-data',
        cache: false,
		dataType: 'json',
        success: function(response){		
			// response is the data you got back from server in JSON format.
			if (response.response != true) {
				bootbox.alert({message: response.response, closeButton: false, className: 'alert'});
			} else {
				jQuery('#mes_photos_fp ul').append(response.datas.content);
				jQuery('#jsonvideo'+video_index+'_url').focus();
			}
        },
 		error: function(err, file) {
			bootbox.alert({message: file.name + Joomla.Text._(err), closeButton: false, className: 'alert'});
		}
   }); 
}

function delete_video(name) {
	jQuery('#'+name).addClass('alert alert-warning');
	setTimeout(() => { 
		jQuery('#'+name).remove();
		update_json_value();
	}, 1000);
}

function update_json_value() {
	var order_data = jQuery('[id^=\"json\"]');
	var json_data_array = new Array();
	var json_lang = new Array();
	var json_array = new Array();
	var json_name = '';
	var tmp1 = '';
	
	order_data.each( function(i) {
		json_data_array = order_data[i].id.split('_');
		if(json_data_array.length == 1) {
			if(json_lang.length > 0) {
				tmp1 = '\"'+json_name+'\":{'+json_lang.join(',')+'}';
				json_array.push(tmp1);
				tmp1 = '';
			}
			json_name = json_data_array[0];
			json_lang = new Array();
		} else {
			json_lang.push('\"' + json_data_array[1].replace('-', '_') + '\":\"'+order_data[i].value.replace(/\"/g, '\\\\\"') + '\"');
		}
	});
	if(json_lang.length > 0) {
		tmp1 = '\"'+json_name+'\":{'+json_lang.join(',')+'}';
		json_array.push(tmp1);
		tmp1 = '';
	}

	jQuery('#jform_params_commentaires_photos').text('{'+json_array.join(',')+'}');
}

jQuery(document).on('dragenter', function (e) 
{
    e.stopPropagation();
    e.preventDefault();
});
jQuery(document).on('dragover', function (e) 
{
  e.stopPropagation();
  e.preventDefault();
  drag_obj_fp.css('border', '2px dotted #0B85A1');
});
jQuery(document).on('drop', function (e) 
{
    e.stopPropagation();
    e.preventDefault();
});

var rowCount=0;
function createStatusbar(drag_obj_fp,file)
{
     rowCount++;
     var row="odd";
     if(rowCount %2 ==0) row ="even";
	 this.preview = jQuery("<div id='preview"+rowCount+"' class='previewfp "+row+"'></div>");
     this.statusbar = jQuery("<div class='statusbar'></div>");
     this.filename = jQuery("<div class='filename'></div>").appendTo(this.statusbar);
     this.size = jQuery("<div class='filesize'></div>").appendTo(this.statusbar);
     this.progressBar = jQuery("<div class='progressBar'><div></div></div>").appendTo(this.statusbar);
     // this.abort = jQuery("<div class='abort'>Abort</div>").appendTo(this.statusbar);+
	 this.statusbar.appendTo(this.preview);
     drag_obj_fp.prepend(this.preview);

	var preview = jQuery('#preview'+rowCount);
				
	var reader = new FileReader();

	reader.onload = function(e){
			// e.target.result holds the DataURL which
			// can be used as a source of the image:
	};

	// Reading the file as a DataURL. When finished,
	// this will trigger the onload function above:
	reader.readAsDataURL(file);

	preview.appendTo('#preview'+rowCount);
	// Associating a preview container
	// with the file, using jQuery's jQuery.data():

	jQuery.data(file,preview);

	this.setFileNameSize = function(name,size)
    {
        var sizeStr="";
        var sizeKB = size/1024;
        if(parseInt(sizeKB) > 1024)
        {
            var sizeMB = sizeKB/1024;
            sizeStr = sizeMB.toFixed(2)+" MB";
        }
        else
        {
            sizeStr = sizeKB.toFixed(2)+" KB";
        }
 
        this.filename.html(name);
        this.size.html(sizeStr);
    }
    this.setProgress = function(progress)
    {       
        var progressBarWidth =progress*this.progressBar.width()/ 100;  
        this.progressBar.find('div').animate({ width: progressBarWidth }, 10).html(progress + "% ");
    }
}

function handleFileUpload(files,drag_obj_fp)
{
   for (var i = 0; i < files.length; i++) 
   {
		max_size = files[i].size / 1024 / 1024;
		if( max_size >= max_upload_size ) {
			bootbox.alert({message: files[i].name + ' : ' + Joomla.Text._('MOD_GALLERYFP_FILE_TOO_LARGE') + (Math.round(max_size * 100) / 100) + ' > ' + max_upload_size + 'Mo', closeButton: false, className: 'alert'});
		} else {
			var data = new FormData();
			data.append('photo_file', files[i]);

			var status = new createStatusbar(drag_obj_fp,files[i]); //Using this we can set progress.
			status.setFileNameSize(files[i].name,files[i].size);
			sendFileToServer(data,status);
		}
   }
}

function sendFileToServer(data,status)
{
	// upload handler, handles each file separately, can also be a function taking the file and returning a url
    jQuery.ajax({
            xhr: function() {
            var xhrobj = jQuery.ajaxSettings.xhr();
            if (xhrobj.upload) {
                    xhrobj.upload.addEventListener('progress', function(event) {
                        var percent = 0;
                        var position = event.loaded || event.position;
                        var total = event.total;
                        if (event.lengthComputable) {
                            percent = Math.ceil(position / total * 100);
                        }
                        //Set progress
                        status.setProgress(percent);
                    }, false);
                }
            return xhrobj;
        },
        url: 'index.php?option=com_ajaxgallerydropfilesfp&task=add&'+token+'=1&module_id='+module_id,
        method: "POST",
        contentType:false,
        processData: false,
		enctype: 'multipart/form-data',
        cache: false,
        data: data,
		dataType: 'json',
        success: function(response){
            status.setProgress(100);
			
			// response is the data you got back from server in JSON format.
			if (response.response != true) {
				bootbox.alert({message: response.response, closeButton: false, className: 'alert'});
			} else {
				jQuery('#mes_photos_fp ul').append(response.datas.content);
			}
			jQuery('#'+status.preview.attr('id')).remove();
        },
 		error: function(err, file) {
			bootbox.alert({message: file.name + Joomla.Text._(err), closeButton: false, className: 'alert'});
		}
   }); 
}

/*Fin de Gestion du drag drop*/

jQuery(document).ready(function() {
	init_photos()
});

function delete_file(file_name, photo_id) {
	jQuery(photo_id).addClass('alert alert-warning');
	jQuery.ajax({
        url: 'index.php?option=com_ajaxgallerydropfilesfp&task=delete&'+token+'=1',
		data: {
			module_id : module_id,
			name : file_name,
			id : photo_id
		},
		dataType: 'json'
	}).done(function(result) {
		if (result.response == true) {
			jQuery('#'+result.datas).remove();
		} else {
			bootbox.alert({message: result, closeButton: false, className: 'alert'});
			jQuery('#'+result.datas).removeClass('remove');
		};
	});
	return false;
}


